*** Link_origin.cpp	2013-06-14 17:15:04.226235014 +0900
--- Link.cpp	2013-05-30 13:43:03.112455524 +0900
***************
*** 297,299 ****
--- 297,330 ----
                << ", subCM = " << vector3(submwc/subm) << std::endl;
      */
  }
+ 
+ 
+ // added by kojima
+ Matrix3d Link::D(Vector3d r){
+   Matrix3d r_cross;
+   r_cross <<
+     0.0,  -r(2), r(1),
+     r(2),    0.0,  -r(0),
+     -r(1), r(0),    0.0;
+   return r_cross.transpose() * r_cross;
+ }
+ 
+ 
+ /**
+    assuming Link::subm, submwc is already computed by calcSubMassCM;
+ */
+ void Link::calcSubInertia()
+ {
+   subIw = R * I * R.transpose() + m * D( wc - submwc/subm );
+   if (child){
+     child->calcSubInertia();
+     subIw +=  child->subIw + child->subm * D( child->submwc/child->subm - submwc/subm );
+     Link *l = child->sibling;
+     while (l){
+       l->calcSubInertia();
+       subIw += l->subIw + l->subm * D( l->submwc/l->subm - submwc/subm );
+       l = l->sibling;
+     }
+   }
+ 
+ }